package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowSecurityGroupRuleLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowSecurityGroupRuleLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowSecurityGroupRuleLogic {
	return &ShowSecurityGroupRuleLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowSecurityGroupRuleLogic) ShowSecurityGroupRule(req *types.ShowSecurityGroupRuleReq) (resp *types.ShowSecurityGroupRuleResp, err error) {
	// todo: add your logic here and delete this line
	ShowSecurityGroupRuleReq := &openstack.ShowSecurityGroupRuleReq{}
	err = copier.CopyWithOption(ShowSecurityGroupRuleReq, req, copier.Option{Converters: utils.Converters})
	ShowSecurityGroupRuleResp, err := l.svcCtx.OpenstackRpc.ShowSecurityGroupRule(l.ctx, ShowSecurityGroupRuleReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ShowSecurityGroupRuleResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowSecurityGroupRuleResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
